"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const rx_value_1 = require("./rx-value");
class RxList extends rx_value_1.default {
    find(predicate) {
        const newSource = this.filter(predicate).asObservable().pipe((0, rxjs_1.map)(values => values[0]));
        return new rx_value_1.default(newSource);
    }
    filter(predicate) {
        const newSource = this.asObservable().pipe((0, rxjs_1.switchMap)((values) => {
            if (values.length === 0)
                return rxjs_1.EMPTY;
            return (0, rxjs_1.combineLatest)(values.map(v => predicate(v).asObservable())).pipe((0, rxjs_1.map)(booleans => values.filter((_, i) => booleans[i])));
        }));
        return new RxList(newSource);
    }
    static ofValues(value) {
        return new RxList((0, rxjs_1.of)(value));
    }
}
exports.default = RxList;
//# sourceMappingURL=rx-list.js.map