"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
class RxValue {
    source = rxjs_1.EMPTY;
    constructor(source) {
        this.source = source;
    }
    get(key) {
        const newSource = this.asObservable().pipe((0, operators_1.pluck)(key));
        return new RxValue(newSource);
    }
    equals(other) {
        return (other instanceof RxValue ?
            this.equalsRxValue(other) :
            this.equalsConst(other));
    }
    equalsRxValue(other) {
        const newSource = (0, rxjs_1.combineLatest)([
            this.asObservable(),
            other.asObservable()
        ]).pipe((0, rxjs_1.map)(([thisVal, otherVal]) => thisVal === otherVal));
        return new RxValue(newSource);
    }
    equalsConst(otherVal) {
        const newSource = this.asObservable().pipe((0, rxjs_1.map)(thisVal => thisVal === otherVal));
        return new RxValue(newSource);
    }
    notEquals(other) {
        return (other instanceof RxValue ?
            this.notEqualsRxValue(other) :
            this.notEqualsConst(other));
    }
    notEqualsRxValue(other) {
        const newSource = (0, rxjs_1.combineLatest)([
            this.asObservable(),
            other.asObservable()
        ]).pipe((0, rxjs_1.map)(([thisVal, otherVal]) => thisVal !== otherVal));
        return new RxValue(newSource);
    }
    notEqualsConst(otherVal) {
        const newSource = this.asObservable().pipe((0, rxjs_1.map)(thisVal => thisVal !== otherVal));
        return new RxValue(newSource);
    }
    asObservable() {
        return this.source;
    }
}
exports.default = RxValue;
//# sourceMappingURL=rx-value.js.map