"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rx_value_1 = require("./rx-value");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function Val(obj) {
    const obsEntries = Object.entries(obj).map(toReactiveEntry);
    const source = (0, rxjs_1.combineLatest)(obsEntries).pipe((0, operators_1.map)(entries => Object.fromEntries(entries)));
    return new rx_value_1.default(source);
}
exports.default = Val;
function toReactiveEntry([key, value]) {
    if (!(value instanceof rx_value_1.default))
        return (0, rxjs_1.of)([key, value]);
    return value.asObservable().pipe((0, operators_1.map)(val => ([key, val])));
}
//# sourceMappingURL=val.js.map